"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

TestCase subclass:#JavaUTF8Tests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests'
!

!JavaUTF8Tests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!JavaUTF8Tests methodsFor:'loadingTests'!

testSingleByteCharacters
    |bytes|

    bytes := ByteArray new:1.
    bytes at:1 put:65.
    self assert:((CharacterArray decodeFromJavaUTF8:bytes) = 'A').

    "Created: / 04-02-2011 / 14:18:10 / Marcel Hlopko <hlopik@gmail.com>"
!

testSixByteCharacters
    | bytes  convertedString  expectedString |

    bytes := ByteArray new: 6.
    bytes at: 1 put: 2r11101101.
    bytes at: 2 put: 2r10101111.
    bytes at: 3 put: 2r10111111.
    bytes at: 4 put: 2r11101101.
    bytes at: 5 put: 2r10111111.
    bytes at: 6 put: 2r10101111.
    expectedString := Unicode32String new: 1.
    expectedString at: 1
        put: (Character codePoint: (((((2r11111111111111111111)))))).
    convertedString := CharacterArray decodeFromJavaUTF8: bytes.
    self assert: convertedString = expectedString.

    "Created: / 04-02-2011 / 15:25:27 / Marcel Hlopko <hlopik@gmail.com>"
    "Modified: / 13-03-2011 / 15:44:24 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testSixByteCharactersTrap
    |bytes convertedString expectedString|

    bytes := ByteArray new:6.
    bytes at:1 put:2r11101101.
    bytes at:2 put:2r10101111.
    bytes at:3 put:2r10111111.
    bytes at:4 put:2r11101101.
    bytes at:5 put:2r10101111.
    bytes at:6 put:2r10111111.
    expectedString := Unicode32String new:2.
    expectedString at:1
        put:(Character codePoint:2r1101101111111111).
    expectedString at:2
                    put:(Character codePoint:2r1101101111111111).
    convertedString := CharacterArray decodeFromJavaUTF8:bytes.
    self assert:convertedString = expectedString.

    "Created: / 04-02-2011 / 16:01:32 / Marcel Hlopko <hlopik@gmail.com>"
!

testThreeByteCharacters
    |bytes convertedString expectedString|

    bytes := ByteArray new:3.
    bytes at:1 put:2r11101111.
    bytes at:2 put:2r10001111.
    bytes at:3 put:2r10101111.
    expectedString := Unicode16String new:1.
    expectedString at:1 put:(Character codePoint:2r1111001111101111).
    convertedString := CharacterArray decodeFromJavaUTF8:bytes.    
    self assert:convertedString = expectedString.

    "Created: / 04-02-2011 / 15:06:03 / Marcel Hlopko <hlopik@gmail.com>"
!

testTwoByteCharacters
    |bytes convertedString expectedString|

    bytes := ByteArray new:2.
    bytes at:1 put:2r11011111.
    bytes at:2 put:2r10001111.
    expectedString := Unicode16String new:1.
    expectedString at:1 put:(Character codePoint:2r11111001111).
    convertedString := CharacterArray decodeFromJavaUTF8:bytes.    
    self assert:convertedString = expectedString.

    "Created: / 04-02-2011 / 14:31:26 / Marcel Hlopko <hlopik@gmail.com>"
    "Modified: / 04-02-2011 / 16:02:16 / Marcel Hlopko <hlopik@gmail.com>"
! !

!JavaUTF8Tests class methodsFor:'documentation'!

version_SVN
    ^ '$Id: JavaUTF8Tests.st,v 1.1 2011-08-18 19:06:53 vrany Exp $'
! !
